<?php
/**
 * @file
 * Form builder for Conference Registration.
 */

/**
 * Conference-registration form constructor.
 *
 * @param $form
 * @param $form_state
 * @param null $data
 * @param null $step
 * @param null $callback
 *
 * @return mixed
 */
function conference_registration_form($form, &$form_state, $type = 'registration', $data = NULL, $step = NULL) {
  $form_info = conference_registration_get_form_info($type);
  $form_steps = array_keys($form_info['steps']);

  if (empty($step)) {
    $current_step = 0;
  }
  else {
    $current_step = array_search($step, $form_steps);
  }

  $form_step = $form_info['steps'][$form_steps[$current_step]];
  $next_step = isset($form_steps[$current_step + 1]) ? $form_steps[$current_step + 1] : NULL;
  /**
   * @var \ConferenceRegistrationStepBase $step
   */
  $step = new $form_step['handler']($data, $form_steps[$current_step], $next_step, $form_info);
  $form_state['build_info']['form_step'] = $step;

  return $step->build_form();
}

/**
 * Validation handler for conference_registration_form().
 *
 * @param $form
 * @param $form_state
 */
function conference_registration_form_validate($form, &$form_state) {
  /**
   * @var \ConferenceRegistrationStepBase $step
   */
  $step = $form_state['build_info']['form_step'];
  $step->validate_form($form, $form_state);
}

/**
 * Submission handler for conference_registration_form().
 * @param $form
 * @param $form_state
 */
function conference_registration_form_submit($form, &$form_state) {
  /**
   * @var \ConferenceRegistrationStepBase $step
   */
  $step = $form_state['build_info']['form_step'];
  $step->submit_form($form, $form_state);
}
